# SoIndexedNurbsSurface Class Reference
[Nodes]

`#include <Inventor/nodes/SoIndexedNurbsSurface.h>`

Inheritance diagram for SoIndexedNurbsSurface:

List of all members.

## Detailed Description

The SoIndexedNurbsSurface class can be used to render NURBS surfaces.

It is very similar to the SoNurbsSurface class, but controlpoints can be specified using indices.

## Public Member Functions

| SoIndexedNurbsSurface (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)
void | sendPrimitive (SoAction *, SoPrimitiveVertex *)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFInt32 | numUControlPoints
SoSFInt32 | numVControlPoints
SoMFInt32 | coordIndex
SoMFFloat | uKnotVector
SoMFFloat | vKnotVector
SoSFInt32 | numSControlPoints
SoSFInt32 | numTControlPoints
SoMFInt32 | textureCoordIndex
SoMFFloat | sKnotVector
SoMFFloat | tKnotVector

## Protected Member Functions

virtual | ~SoIndexedNurbsSurface ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)
SoDetail * | createTriangleDetail (SoRayPickAction *action, const SoPrimitiveVertex *v1, const SoPrimitiveVertex *v2, const SoPrimitiveVertex *v3, SoPickedPoint *pp)

## Friends

class | SoIndexedNurbsSurfaceP

## Constructor & Destructor Documentation

SoIndexedNurbsSurface::SoIndexedNurbsSurface | ( | void |  | ) |

| Constructor.

SoIndexedNurbsSurface::~SoIndexedNurbsSurface | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoIndexedNurbsSurface::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoShape.

void SoIndexedNurbsSurface::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoIndexedNurbsSurface::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoIndexedNurbsSurface::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoIndexedNurbsSurface::sendPrimitive | ( | SoAction * | ,
|  | SoPrimitiveVertex * |
| ) |

| This method is part of the original SGI Inventor API, but not implemented in Coin, as it looks like a method that should probably have been private in Open Inventor.

void SoIndexedNurbsSurface::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoIndexedNurbsSurface::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

| Calculates the bounding box of all control points and sets the center to the average of these points. Implements SoShape.

SoDetail * SoIndexedNurbsSurface::createTriangleDetail | ( | SoRayPickAction * | action,
|  | const SoPrimitiveVertex * | v1,
|  | const SoPrimitiveVertex * | v2,
|  | const SoPrimitiveVertex * | v3,
|  | SoPickedPoint * | pp
| ) | `[protected, virtual]`

Will create triangle detail for a SoPickedPoint. This method will only be called internally, when generatePrimitives() is used for picking (SoShape::rayPick() is not overridden).

This method returns `NULL` in Open Inventor, and subclasses will need to override this method to create details for a SoPickedPoint.

This is not necessary with Coin. Of course, if you choose to override it, it will work in the same way as Open Inventor.

For this to work, you must supply a face or line detail when generating primitives. If you supply `NULL` for the detail argument in SoShape::beginShape(), you'll have to override this method.

Reimplemented from SoShape.

## Member Data Documentation

SoSFInt32 SoIndexedNurbsSurface::numUControlPoints

| Number of control points in the U direction.

SoSFInt32 SoIndexedNurbsSurface::numVControlPoints

| Number of control points in the V direction.

SoMFInt32 SoIndexedNurbsSurface::coordIndex

| The coordinate control point indices.

SoMFFloat SoIndexedNurbsSurface::uKnotVector

| The Bezier knot vector for the U direction.

SoMFFloat SoIndexedNurbsSurface::vKnotVector

| The Bezier knot vector for the V direction.

SoSFInt32 SoIndexedNurbsSurface::numSControlPoints

| Number of control points in the S direction.

SoSFInt32 SoIndexedNurbsSurface::numTControlPoints

| Number of control points in the T direction.

SoMFInt32 SoIndexedNurbsSurface::textureCoordIndex

| The texture coordinate control point indices.

SoMFFloat SoIndexedNurbsSurface::sKnotVector

| The Bezier knot vector for the S direction.

SoMFFloat SoIndexedNurbsSurface::tKnotVector

| The Bezier knot vector for the T direction.

The documentation for this class was generated from the following files:

- SoIndexedNurbsSurface.h
- SoIndexedNurbsSurface.cpp